#include <stdio.h>
#include "ets_sys.h"
#include "osapi.h"
#include "user_interface.h"
#include "gpio.h"
#include "max7219.h"
#include "driver/spi.h"
#include "spi_user.h"
//------------------------------------------------------
uint32 ICACHE_FLASH_ATTR user_rf_cal_sector_set(void)
{
    enum flash_size_map size_map = system_get_flash_size_map();
    uint32 rf_cal_sec = 0;

    switch (size_map) {
        case FLASH_SIZE_4M_MAP_256_256:
            rf_cal_sec = 128 - 8;
            break;

        case FLASH_SIZE_8M_MAP_512_512:
            rf_cal_sec = 256 - 5;
            break;

        case FLASH_SIZE_16M_MAP_512_512:
        case FLASH_SIZE_16M_MAP_1024_1024:
            rf_cal_sec = 512 - 5;
            break;

        case FLASH_SIZE_32M_MAP_512_512:
        case FLASH_SIZE_32M_MAP_1024_1024:
            rf_cal_sec = 1024 - 5;
            break;

        default:
            rf_cal_sec = 0;
            break;
    }
    return rf_cal_sec;
}
//------------------------------------------------------
void ICACHE_FLASH_ATTR user_init()
{
  uint16_t i=0;
  gpio_init();
  spi_init(HSPI);
  Init_7219();
  Number_7219(87654321);
  ets_delay_us(1000000);
  system_soft_wdt_feed();
  ets_delay_us(1000000);
  system_soft_wdt_feed();
  Clear_7219();
  while(1)
  {
    i++;
    if(i>9999) i=0;
    NumberR_7219(i);
    NumberL_7219(9999-i);
    ets_delay_us(100000);
    system_soft_wdt_feed();
  }
}
//------------------------------------------------------
